Rails.application.routes.draw do

  locales = Site.first.in_use_locales rescue I18n.available_locales
  scope "(:locale)", locale: Regexp.new(locales.join("|")) do
   namespace :admin do
    get "/feeds/get_channel_list", to: 'feeds#get_channel_list'
    post "/feeds/get_feed_list", to: 'feeds#get_feed_list'
    get "/feeds/get_category_list", to: 'feeds#get_category_list'
    post "/feeds/subscribe", to: 'feeds#subscribe'
    post "/feeds/unsubscribe", to: 'feeds#unsubscribe'
    post "/feeds/disable", to: 'feeds#disable'
    post "/feeds/channel_title", to: 'feeds#channel_title'
    resources :feeds,only: ['new','index']
    get '/feeds/settings' => 'feeds#settings'
    patch '/feeds/update_settings' => 'feeds#update_settings'
    get '/feeds/announcements' => 'feeds#announcements'
    post '/feeds/process_annc' => 'feeds#process_annc'
    get '/feeds/annc_content' => 'feeds#annc_content'
    post "/feeds/force_refresh", to: 'feeds#force_refresh'
   end
  end
  post "/xhr/feeds/notify_change" => "feeds#notify_change"
end
